Bug 172592 - Athlon XP s2k disconnect irreversibly disabled after attaching USB storage device
Athlon XP s2k disconnect irreversibly disabled after attaching USB storage de...
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
6
i386 Linux
medium Severity medium
: ---
: ---
Assigned To: Pete Zaitcev
Brian Brock
NeedsRetesting
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2005-11-07 13:15 EST by Dave Jenkins
Modified: 2008-01-03 13:04 EST (History)
3 users (show)

See Also:
Fixed In Version: 2.6.23.9-85.fc8
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-01-03 13:04:26 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dave Jenkins 2005-11-07 13:15:21 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.12) Gecko/20050922 Fedora/1.0.7-1.1.fc4 Firefox/1.0.7

Description of problem:
I recently discovered and enabled my motherboard's CPU Disconnect Control, which is described thus:

"The item is to reduce the power consumption of the AMD K7 system. When set to Enabled, the processor is allowed to disconnect the s2k interface when the AMD K7 system is in some power saving states."

It works a treat, lowering my CPU idle temperature by about 7 degrees C. However if I plug in a USB mass storage device (in my case a Sony P200 camera), the CPU temp rises to where it was without the power saving, and stays there. Even after disconnecting the USB device, rmmod-ing or modprobe -r -ing all the modules that got installed for the device (usb_storage, scsi, vfat etc), logging out, even telinit 1. The only thing I've found that gets the CPU temp back down is a reboot.

Further info: following a reboot, in order to investigate what provokes the problem, I tried individually modprobe-ing the modules that get loaded for usb_storage: fat, vfat, scsi_mod, sd_mod and usb_storage. None of these triggered the temperatuire rise. Only when I plugged in the device did the CPU temp go up. This happens regardless of whether I enable automatic mounting of removable drives.

I hope it is appropriate to file this as a bug, I am open to workarounds.

Version-Release number of selected component (if applicable):
kernel-2.6.13-1.1532_FC4

How reproducible:
Always

Steps to Reproduce:
0. Note CPU temps with & without s2k disconnect enabled in BIOS.
1. Enable s2k disconnect in BIOS.
2. Note initial CPU temp.
3. Attach and detach USB storage device (no need to do anything with it).
4. Note subsequent CPU temp.


Actual Results:  Subsequent CPU temp remains at level previously observed with s2k disconnect disabled in BIOS.

Expected Results:  Subsequent CPU temp should fall to level previously observed with s2k disconnect enabled in BIOS.

Additional info:

Hardware: Athlon XP 2600+ Barton, MSI KM4M-L motherboard (Via KM400).
Comment 1 Pete Zaitcev 2005-11-07 18:13:28 EST
I can take it but I do not expect to devote a lot of time to this.

It looks like some sort of DMA gets enabled, perhaps the hub interrupt
transfer.

I see the HC driver wasn't in the list of removed modules (ohci or ehci,
depending on the USB speed). Try removing that one as well.
Comment 2 Dave Jenkins 2005-11-09 13:36:49 EST
Thanks for the reply, Pete. I quite understand that this isn't going to be a
high-priority bug. Further results...

1) After attaching & detaching the USB storage device (whereupon CPU
power-saving is lost),
modprobe -r ehci_hcd
restores the power-saving. :-)
(ehci_hcd and uhci_hcd are both loaded by default at boot on my system, and
ehci_hcd registers the usb_storage device.)

2) After attaching & detaching the USB storage device with ehci_hcd still
removed, uhci_hcd registers the device and power-saving is NOT lost.

So I have a workaround and I hope these results are of some help.

Dave
Comment 3 Dave Jones 2005-11-10 14:29:15 EST
2.6.14-1.1637_FC4 has been released as an update for FC4.
Please retest with this update, as a large amount of code has been changed in
this release, which may have fixed your problem.

Thank you.
Comment 4 Dave Jenkins 2005-11-11 06:42:28 EST
Dave, thanks for your response. I have tested with 2.6.14-1.1637_FC4, however
the behaviour is the same as with 2.6.13-1.1532_FC4.
Comment 5 Dave Jones 2006-02-03 00:32:11 EST
This is a mass-update to all currently open kernel bugs.

A new kernel update has been released (Version: 2.6.15-1.1830_FC4)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO_REPORTER state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

Thank you.
Comment 6 Dave Jenkins 2006-02-04 13:37:41 EST
Tested with kernel-2.6.15-1.1830_FC4.

Results: the problem is much worse with this kernel. The CPU does not go into
power-saving at all. I have tried to track down the culprit by booting into
runlevel 1, then removing all unused modules, just leaving those required for
lm_sensors so that I can check the CPU temp. This is the smallest set of
modulesI got down to:

Module                  Size  Used by
w83627hf               24017  0
hwmon_vid               2753  1 w83627hf
hwmon                   3269  1 w83627hf
i2c_isa                 5185  1 w83627hf
i2c_core               21697  2 w83627hf,i2c_isa
ext3                  129993  8
jbd                    57941  1 ext3
dm_mod                 56665  9

(w83627hf is the module for the Winbond chip queried my lm_sensors).
With just these modules loaded, in runlevel 1 with the system idling, the CPU
still does not go into power-saving mode. With the low-speed CPU fan I'm
currently using, the difference in CPU temp between 2.6.14_1656 and 2.6.15_1830
at idle is 10 to 15°C. So if anyone can help with this, they will be doing
their bit to reduce global warming! :-)

As this problem is no longer specific to USB, should I file a new bug or change
the title of this one?

Thanks in advance for any help.
Comment 7 Dave Jenkins 2006-02-07 08:33:57 EST
I've created new bug 180338: "2.6.15 on Athlon XP CPU runs hot: blocks s2k
disconnect power saving" for this much more general, non-USB-specific problem.
Comment 8 Pete Zaitcev 2006-09-11 20:11:51 EDT
I track other reports that active USB damages power management, too.
We're working upstream on things like not polling the root hub in OHCI
and things of that nature. But this seems like an uphill battle,
because I don't have any AMD hardware myself. So it's all at-user-place
testing.
Comment 9 Dave Jones 2006-09-16 22:04:28 EDT
[This comment added as part of a mass-update to all open FC4 kernel bugs]

FC4 has now transitioned to the Fedora legacy project, which will continue to
release security related updates for the kernel.  As this bug is not security
related, it is unlikely to be fixed in an update for FC4, and has been migrated
to FC5.

Please retest with Fedora Core 5.

Thank you.
Comment 10 Dave Jones 2006-10-16 14:07:40 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.
Comment 11 Dave Jenkins 2006-11-28 14:17:52 EST
Tested on 2.6.18-1.2849.fc6
I now have a power monitor that enables me to measure my PC's power usage at the
wall plug. On connecting the Sony P200 camera, power usage rises by 10 to 15
Watts. It remains at this level until I modprobe -r ehci_hcd.
Comment 12 Jon Stanley 2007-12-30 17:55:19 EST
Does this still occur in F8?  I'll close in a few days if there's no response.
Comment 13 Dave Jenkins 2008-01-03 12:55:47 EST
Problem seems to be fixed in 2.6.23.9-85.fc8: power usage drops to previous
level after unplugging the camera.

Thanks and Happy New Year, Dave.
Comment 14 Jon Stanley 2008-01-03 13:04:26 EST
Thanks, closing CURRENTRELEASE

Note You need to log in before you can comment on or make changes to this bug.